package com.example.vaadinwidgetset;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Button;
import com.vaadin.ui.Button.ClickEvent;
import com.vaadin.ui.GridLayout;
import com.vaadin.ui.Notification;
import com.vaadin.ui.UI;

@SuppressWarnings("serial")
@Theme("vaadinwidgetset")
public class VaadinwidgetsetUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = VaadinwidgetsetUI.class, widgetset = "com.example.vaadinwidgetset.VaadinwidgetsetWidgetset")
	public static class Servlet extends VaadinServlet {
	}

	@Override
	protected void init(VaadinRequest request) {
		final GridLayout layout = new GridLayout(3, 2);
		layout.setWidth("80%");
		layout.setHeight("80%");
		layout.setMargin(true);
		setContent(layout);

		Button button = new Button("Vaadin Button");
		button.addClickListener(new Button.ClickListener() {
			public void buttonClick(ClickEvent event) {
			  Notification.show("Clicked: Vaadin Button",Notification.Type.TRAY_NOTIFICATION);
			}
		});
		layout.addComponent(button, 0, 0);

		Listener myListener = new Listener(){
			@Override
			public void componentEvent(Event event)
			{
				MyGwtbootstrap3 gg = (MyGwtbootstrap3)event.getComponent();
				Notification.show("Clicked: Bootstrap " + gg.getMyGwtbootstrap3Text(),Notification.Type.TRAY_NOTIFICATION);
			}
		};
		
		MyGwtbootstrap3 b01 = new MyGwtbootstrap3("Info", "INFO", "DEFAULT");
		b01.addListener(myListener);
		layout.addComponent(b01, 0, 1);
		MyGwtbootstrap3 b02 = new MyGwtbootstrap3("Primary", "PRIMARY", "DEFAULT");
		b02.addListener(myListener);
		layout.addComponent(b02, 1, 0);

		MyGwtbootstrap3 b03 = new MyGwtbootstrap3("Success", "SUCCESS", "DEFAULT");
		b03.addListener(myListener);
		layout.addComponent(b03, 1, 1);

		MyGwtbootstrap3 b04 = new MyGwtbootstrap3("Warning", "WARNING", "DEFAULT");
		b04.addListener(myListener);
		layout.addComponent(b04, 2, 0);

		MyGwtbootstrap3 b05 = new MyGwtbootstrap3("Danger", "DANGER", "DEFAULT");
		b05.addListener(myListener);
		layout.addComponent(b05, 2, 1);
	}

}