package com.example.vaadinwidgetset.client.mygwtbootstrap3;

import org.gwtbootstrap3.client.ui.constants.ButtonSize;
import org.gwtbootstrap3.client.ui.constants.ButtonType;

import com.example.vaadinwidgetset.MyGwtbootstrap3;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Widget;
import com.vaadin.client.MouseEventDetailsBuilder;
import com.vaadin.client.communication.RpcProxy;
import com.vaadin.client.communication.StateChangeEvent;
import com.vaadin.client.ui.AbstractComponentConnector;
import com.vaadin.shared.MouseEventDetails;
import com.vaadin.shared.ui.Connect;

@Connect(MyGwtbootstrap3.class)
public class MyGwtbootstrap3Connector extends AbstractComponentConnector implements ClickHandler {

	private static final long serialVersionUID = 1L;
	MyGwtbootstrap3ServerRpc rpc = RpcProxy
			.create(MyGwtbootstrap3ServerRpc.class, this);
	
	public MyGwtbootstrap3Connector() {

		getWidget().addClickHandler(this);

	}

	@Override
	protected Widget createWidget() {
		return GWT.create(MyGwtbootstrap3Widget.class);
	}

	@Override
	public MyGwtbootstrap3Widget getWidget() {
		return (MyGwtbootstrap3Widget) super.getWidget();
	}

	@Override
	public MyGwtbootstrap3State getState() {
		return (MyGwtbootstrap3State) super.getState();
	}

	@Override
	public void onStateChanged(StateChangeEvent stateChangeEvent) {
		super.onStateChanged(stateChangeEvent);

		MyGwtbootstrap3State state = getState();
		MyGwtbootstrap3Widget button = getWidget();

		button.setText(state.getText());
		button.setSize(ButtonSize.valueOf(state.getSize()));
		button.setType(ButtonType.valueOf(state.getType()));
	
	}

	@Override
	public void onClick(ClickEvent event) {
		MouseEventDetails details = MouseEventDetailsBuilder.buildMouseEventDetails(
				event.getNativeEvent(), getWidget().getElement());

		rpc.clicked(details);
	}

}

